# The building of jaxb  depend on jaxb-fi, and the latter requires jaxb
# When building jaxb. for bootstrap, we use offline repository from maven central.
%bcond_with bootstrap

Summary:        JAXB Reference Implementation
Name:           jaxb
Version:        4.0.2
Release:        4%{?dist}
License:        BSD
URL:            https://github.com/eclipse-ee4j/jaxb-ri

Source0:        %{url}/archive/%{version}-RI/%{name}-%{version}.tar.gz
%if %{with bootstrap}
Source1:        repository.tar.gz
%endif

BuildRequires: maven-local mvn(com.sun.istack:istack-commons-runtime) mvn(com.sun.istack:istack-commons-tools)
BuildRequires: mvn(com.sun.xml.dtd-parser:dtd-parser) mvn(jakarta.activation:jakarta.activation-api)
BuildRequires: mvn(jakarta.xml.bind:jakarta.xml.bind-api) mvn(org.apache.ant:ant)
BuildRequires: mvn(org.apache.felix:maven-bundle-plugin) mvn(org.apache.maven.plugins:maven-assembly-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-dependency-plugin)
BuildRequires: mvn(org.apache.maven.plugins:maven-source-plugin) mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires: mvn(org.jvnet.staxex:stax-ex)
%if %{without bootstrap}
BuildRequires:  mvn(com.sun.xml.fastinfoset:FastInfoset)
%endif
BuildArch:      noarch

%description
GlassFish JAXB Reference Implementation.

%package codemodel
Summary:        Codemodel Core

%description codemodel
The core functionality of the CodeModel java source code generation library.

%package codemodel-annotation-compiler
Summary:        Codemodel Annotation Compiler

%description codemodel-annotation-compiler
The annotation compiler ant task for the CodeModel java source code generation
library.

%package relaxng-datatype
Summary:        RelaxNG Datatype

%description relaxng-datatype
RelaxNG Datatype library.

%package xsom
Summary:        XML Schema Object Model

%description xsom
XML Schema Object Model (XSOM) is a Java library that allows applications to easily parse XML Schema
documents and inspect information in them. It is expected to be useful for applications that need to
take XML Schema as an input.

%package core
Summary:        JAXB Core

%description core
JAXB Core module. Contains sources required by XJC, JXC and Runtime modules.

%package rngom
License:        MIT and BSD
Summary:        RELAX NG Object Model/Parser

%description rngom
This package contains RELAX NG Object Model/Parser.

%package runtime
Summary:        JAXB Runtime

%description runtime
JAXB (JSR 222) Reference Implementation

%package txw2
Summary:        TXW2 Runtime

%description txw2
TXW is a library that allows you to write XML documents.

%package xjc
License:        BSD and ASL 2.0
Summary:        JAXB XJC

%description xjc
JAXB Binding Compiler. Contains source code needed for binding customization files into java
sources. In other words: the tool to generate java classes for the given xml representation.

%package txwc2
Summary:        TXW2 Compiler

%description txwc2
JAXB schema generator. The tool to generate XML schema based on java classes.

%prep
%autosetup -n jaxb-ri-%{version}-RI

%if %{with bootstrap}
rm -rf ${HOME}/.m2
mkdir -p ${HOME}/.m2/repository/
cp %{SOURCE1} ${HOME}/.m2/
pushd  ${HOME}/.m2/
tar zxf %{SOURCE1}
popd
%endif

pushd jaxb-ri

%pom_remove_parent boms/bom codemodel external xsom

%pom_remove_plugin -r :buildnumber-maven-plugin
%pom_remove_plugin -r :maven-enforcer-plugin

%pom_xpath_remove "pom:profiles/pom:profile[pom:id='default-profile']/pom:modules"

%pom_disable_module bundles

%pom_disable_module jxc

%pom_remove_dep org.eclipse.angus:angus-activation core

%mvn_package :jaxb-bom __noinstall
%mvn_package :jaxb-bom-ext __noinstall
%mvn_package :jaxb-bundles __noinstall
%mvn_package :jaxb-codemodel-parent __noinstall
%mvn_package :jaxb-docs-parent __noinstall
%mvn_package :jaxb-external-parent __noinstall
%mvn_package :jaxb-parent __noinstall
%mvn_package :jaxb-runtime-parent __noinstall
%mvn_package :jaxb-samples __noinstall
%mvn_package :jaxb-txw-parent __noinstall
%mvn_package :jaxb-www __noinstall
popd

%build
pushd jaxb-ri
%mvn_build -s -f -j
popd

%install
pushd jaxb-ri
%mvn_install
popd

%files codemodel -f jaxb-ri/.mfiles-codemodel
%license LICENSE.md NOTICE.md

%files codemodel-annotation-compiler -f jaxb-ri/.mfiles-codemodel-annotation-compiler

%files relaxng-datatype -f jaxb-ri/.mfiles-relaxng-datatype
%license LICENSE.md NOTICE.md

%files xsom -f jaxb-ri/.mfiles-xsom

%files core -f jaxb-ri/.mfiles-jaxb-core

%files rngom -f jaxb-ri/.mfiles-rngom

%files runtime -f jaxb-ri/.mfiles-jaxb-runtime

%files txw2 -f jaxb-ri/.mfiles-txw2
%license LICENSE.md NOTICE.md

%files txwc2 -f jaxb-ri/.mfiles-txwc2

%files xjc -f jaxb-ri/.mfiles-jaxb-xjc

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.2-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 4.0.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Thu Apr 27 2023 Shuo Wang <abushwang@tencent.com> - 4.0.2-2
- close bootstrap build

* Thu Apr 27 2023 Shuo Wang <abushwang@tencent.com> - 4.0.2-1
- initial build
